mod Ex03b

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  3. CVIČENIE Z PREDMETU 2-INF-264 TEÓRIA DEKLARATÍVNEHO 
  PROGRAMOVANIA  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end pondelok 5.10.2015 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-INF-264-tdp/1516zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované základnému 
  vývoju primitívne rekurzívnych funkcií (explicitné a primitívne 
  rekurzívne definície). Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 4 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 0 
  \end
  \para Odovzdať do 4.10.2015 (nedeľa) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/0 Tex_f0_m
  Std('m',0)

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Primitive Recursive Definitions.  \end 

rem 
  \para \bf  Subsection. Primitive Recursive Definitions.  \end 

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Show that primitive recursive 
  functions are closed under iteration of unary functions. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Iteration_of_unary_function

fun F 'Tex_f1_f'

rem 
  \para \header* fun/2 If 'Tex_f2_if' \end Show that if \ft Tex_f0_f \end is a 
  unary p.r. function then so is its iteration \ft If(n,x) \end defined by 

fun/2 If 'Tex_f2_if'
  If(0,x) = x
  If(n+1,x) = F If(n,x)

rem 
  \para \it  Proof.  \end 

fun/2 If_is_primrec 'Tex_f2_if'
  If_is_primrec(n,x) = Foo

end theory Iteration_of_unary_function

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _i  \end. 

rem 
  \para \bf  Exercise.  \end Show that primitive recursive functions are closed 
  under monadic discrimination. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Monadic_discrimination

fun G 'Tex_f1_g'

fun/2 H1 'Tex_f2_h'

rem 
  \para \header* fun F 'Tex_f1_f' \end Show that if \ft Tex_f0_g \end and 
  \ft Tex_f0_h \end are p.r. functions then so is the function \ft Tex_f0_f \end 
  defined by 

fun/2 F 'Tex_f2_f'
  F(0,y) = G(y)
  F(x+1,y) = H1(x,y)

rem 
  \para \it  Proof.  \end 

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Monadic_discrimination

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _m  \end. 

rem 
  \para \bf  Exercise. \it  (2 points)  \end  \end Show that primitive recursive 
  functions are closed under primitive recursive definitions with parameters. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Primitive_recursive_definition_with_parameters

fun/2 G 'Tex_f2_g'

fun/4 H1 'Tex_f4_h'

rem 
  \para \header* fun/3 F 'Tex_f3_f' \end Show that if \ft Tex_f0_g \end and 
  \ft Tex_f0_h \end are p.r. functions then so is the function \ft Tex_f0_f \end 
  defined by 

fun/3 F 'Tex_f3_f'
  F(y,0,z) = G(y,z)
  F(y,x+1,z) = H1(y,x,F(y,x,z),z)

rem 
  \para \it  Proof.  \end 

fun/3 F_is_primrec 'Tex_f3_f'
  F_is_primrec(y,x,z) = Foo

end theory Primitive_recursive_definition_with_parameters

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _d  \end. 

rem 
  \para \bf  Lemma.  \end Primitive recursive functions are closed under 
  primitive recursive definitions with parameters. 

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Show that primitive recursive 
  functions are closed under parameterless primitive recursive definitions. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Parameterless_primitive_recursive_definition

fun/0 M1 'Tex_f0_m'

fun/2 H1 'Tex_f2_h'

rem 
  \para \header* fun F 'Tex_f1_f' \end Show that if \ft Tex_f0_h \end is a p.r. 
  function then so is the function \ft Tex_f0_f \end defined by 

fun F 'Tex_f1_f'
  F(0) = M1
  F(x+1) = H1(x,F(x))

rem 
  \para \it  Proof.  \end 

fun F_is_primrec 'Tex_f1_f'
  F_is_primrec(x) = Foo

end theory Parameterless_primitive_recursive_definition

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _p  \end. 

rem 
  \para \bf  Lemma.  \end Primitive recursive functions are closed under 
  parameterless primitive recursive definitions. 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  primitive recursive definitions. 

rem 
  \para \bf  Subsection. Examples of Primitive Recursive Functions.  \end 

rem 
  \para \bf  Exercise.  \end Show that the multiplication function \ft x*y \end 
  is primitive recursive. 

fun/2 Times 'Tex_f2_n_times'
  Times(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x*y \end. 

rem 
  \para \bf  Exercise.  \end Show that the exponentiation function 
  \ft Tex_f2_n_exp(x,y) \end is primitive recursive. 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Show that the summation function 
  \ft Tex_f1_n_sum(n) \end is primitive recursive. 

fun Sum 'Tex_f1_n_sum'
  Sum(n) = Foo

rem 
  \para \bf  Exercise.  \end Show that the predecessor function \ft x-1 \end is 
  primitive recursive. 

fun Pred 'Tex_f1_rec_pred'
  Pred(x) = Foo

rem 
  \para \bf  Exercise.  \end Show that the modified subtraction function 
  \ft x-y \end is primitive recursive. 

fun/2 Minus 'Tex_f2_n_minus'
  Minus(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x-y \end. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

